{*******************************************************}
{                                                       }
{       LightWindows                                    }
{       Interfaces                                      }
{                                                       }
{       2001..2006 YT                                   }
{                                                       }
{*******************************************************}

{ Synchronization }

type
	IReadWriteSyncEx = interface(IReadWriteSync)
		['{2F20FD00-AAF6-4859-9B01-5CCDC2A44BE2}']
		function TryBeginWrite: Boolean;
		procedure Async;
		procedure RestoreAsync;
	end;

{ Observer / Observable }

	IObserver = interface(IInterface)
		['{D979EA03-B050-4201-BF77-0287F9340751}']
		procedure Observe;
	end;

	IObservable = interface(IInterface)
		['{27BF0C3D-232E-470A-8259-E7AF2DFEAEE1}']
		procedure Attach(const AView: IObserver);
		procedure Detach(const AView: IObserver);
		function HasClients: Boolean;
	end;

{ Actions }

	IActionItems = interface;

	IActionItem = interface(IInterface)
		['{460174E6-163E-4FF7-8C5F-D8FB1A206721}']
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
		property Text: WideString read GetText;
		property Checked: Boolean read GetChecked;
		property Items: IActionItems read GetItems;
	end;

	CEachActionItem = function(const Item: IActionItem; Context: Pointer): Boolean; cdecl;

	IActionItems = interface(IInterface)
		['{3311478D-B8EF-489C-8BF4-6365CE76449C}']
		function GetTitle: WideString;
		function Enumerate(Proc: CEachActionItem; Context: Pointer): IActionItem;
		procedure PostUpdate;
		property Title: WideString read GetTitle;
	end;

	IAction = interface(IActionItem)
		['{3B54F30A-CE6B-4DA3-A1C5-EE819825B566}']
		function GetName: string;
		function GetHint: WideString;
		function GetEnabled: Boolean;
		property Name: string read GetName;
		property Hint: WideString read GetHint;
		property Enabled: Boolean read GetEnabled;
	end;

	IActionManager = interface(IInterface)
		['{7FCB0FED-CA3C-41FA-98DF-AE3496A20572}']
		procedure Attach(const AAction: IAction);
		procedure Detach(const AAction: IAction);
		function GetActions(const AName: string): IAction;
		property Actions[const AName: string]: IAction read GetActions; default;
		function Select(const AItems: IActionItems): IActionItem;
	end;

{ Key }

	TShiftKeys = set of (ssAlt, ssControl, ssShift, ssWin);

	{L[蓖}
	IKeyAssignment = interface(IInterface)
		['{7591EAD9-456C-44ED-9DEC-8E30329A600C}']
		function GetTable(const Shift: TShiftKeys; Key: Integer): IAction;
		property Table[const Shift: TShiftKeys; Key: Integer]: IAction read GetTable;
	end;

	IKeyManager = interface(IInterface)
		['{3C792850-4195-4C19-BB13-DE16BF6B0EB3}']
		procedure Attach(const AAssignment: IKeyAssignment);
		procedure Detach(const AAssignment: IKeyAssignment);
		function FindAction(const Shift: TShiftKeys; AKey: Integer): IAction;
	end;

